package de.kif.backend.util

import com.vladsch.flexmark.ext.autolink.AutolinkExtension
import com.vladsch.flexmark.ext.emoji.EmojiExtension
import com.vladsch.flexmark.ext.gfm.strikethrough.StrikethroughExtension
import com.vladsch.flexmark.ext.gfm.tasklist.TaskListExtension
import com.vladsch.flexmark.ext.tables.TablesExtension
import com.vladsch.flexmark.util.ast.Node;
import com.vladsch.flexmark.html.HtmlRenderer;
import com.vladsch.flexmark.parser.Parser;
import com.vladsch.flexmark.util.options.MutableDataSet;
import java.util.*

/*
import org.intellij.markdown.flavours.commonmark.CommonMarkFlavourDescriptor
import org.intellij.markdown.html.HtmlGenerator
import org.intellij.markdown.parser.MarkdownParser

fun markdownToHtml(content: String): String {
    val flavour = CommonMarkFlavourDescriptor()
    val parsedTree = MarkdownParser(flavour).buildMarkdownTreeFromString(content)
    val html = HtmlGenerator(content, parsedTree, flavour).generateHtml()
    return html
}
 */
/*
import org.commonmark.parser.Parser
import org.commonmark.renderer.html.HtmlRenderer

fun markdownToHtml(content: String): String {
    val parser = Parser.builder().build()
    val document = parser.parse(content)
    val renderer = HtmlRenderer.builder().build()
    return renderer.render(document)
}

 */

fun markdownToHtml(content: String): String {
    val options = MutableDataSet()

    options.set(Parser.EXTENSIONS, Arrays.asList(
        TablesExtension.create(),
        StrikethroughExtension.create(),
        TaskListExtension.create(),
        EmojiExtension.create(),
        AutolinkExtension.create()
    ));

    //options.set(HtmlRenderer.SOFT_BREAK, "<br />\n");

    val parser = Parser.builder(options).build()
    val renderer = HtmlRenderer.builder(options).build()

    // You can re-use parser and renderer instances
    val document = parser.parse(content)
    val html = renderer.render(document)

    return html
}